io.vertx.core.eventbus

## Interface MessageConsumer<T>

- All Superinterfaces:
    ReadStream<Message<T>>, StreamBase

      public interface MessageConsumer<T>
      extends ReadStream<Message<T>>

  An event bus consumer object representing a stream of message to an `EventBus` address that can be read from.

  The `EventBus.consumer(String)` or `EventBus.localConsumer(String)` creates a new consumer, the returned consumer is not yet registered against the event bus. Registration is effective after the `handler(io.vertx.core.Handler)` method is invoked.

  The consumer is unregistered from the event bus using the `unregister()` method or by calling the `handler(io.vertx.core.Handler)` with a null value..

  Author:
    Nick Scavelli

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `address()`
    `ReadStream<T>` | `bodyStream()`
    `void` | `completionHandler(Handler<AsyncResult<Void>> completionHandler)` Optional method which can be called to indicate when the registration has been propagated across the cluster.
    `MessageConsumer<T>` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `MessageConsumer<T>` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `MessageConsumer<T>` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `int` | `getMaxBufferedMessages()`
    `MessageConsumer<T>` | `handler(Handler<Message<T>> handler)` Set a data handler.
    `boolean` | `isRegistered()`
    `MessageConsumer<T>` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Future<MessageConsumer<T>>` | `registration()`
    `void` | `registration(Handler<AsyncResult<MessageConsumer<T>>> handler)`
    `MessageConsumer<T>` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `MessageConsumer<T>` | `setMaxBufferedMessages(int maxBufferedMessages)` Set the number of messages this registration will buffer when this stream is paused.
    `Future<Void>` | `unregister()` Unregisters the handler which created this registration
    `void` | `unregister(Handler<AsyncResult<Void>> completionHandler)` Unregisters the handler which created this registration

    - ### Methods inherited from interface io.vertx.core.streams.ReadStream

      `pipe, pipeTo, pipeTo`

- - ### Method Detail

    - #### exceptionHandler

          MessageConsumer<T> exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Message<T>>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          MessageConsumer<T> handler(Handler<Message<T>> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Message<T>>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          MessageConsumer<T> pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Message<T>>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          MessageConsumer<T> resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Message<T>>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          MessageConsumer<T> fetch(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Message<T>>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          MessageConsumer<T> endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Message<T>>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### bodyStream

          ReadStream<T> bodyStream()

      Returns:
        a read stream for the body of the message stream.

    - #### isRegistered

          boolean isRegistered()

      Returns:
        true if the current consumer is registered

    - #### address

          String address()

      Returns:
        The address the handler was registered with.

    - #### setMaxBufferedMessages

          MessageConsumer<T> setMaxBufferedMessages(int maxBufferedMessages)

      Set the number of messages this registration will buffer when this stream is paused. The default value is `1000`.

      When a new value is set, buffered messages may be discarded to reach the new value. The most recent messages will be kept.

      Parameters:
        `maxBufferedMessages` - the maximum number of messages that can be buffered
      Returns:
        this registration

    - #### getMaxBufferedMessages

          int getMaxBufferedMessages()

      Returns:
        the maximum number of messages that can be buffered when this stream is paused

    - #### completionHandler

          void completionHandler(Handler<AsyncResult<Void>> completionHandler)

      Optional method which can be called to indicate when the registration has been propagated across the cluster.
      Parameters:
        `completionHandler` - the completion handler

    - #### registration

          void registration(Handler<AsyncResult<MessageConsumer<T>>> handler)

    - #### registration

          Future<MessageConsumer<T>> registration()

      Returns:
        a future completed

    - #### unregister

          Future<Void> unregister()

      Unregisters the handler which created this registration

    - #### unregister

          void unregister(Handler<AsyncResult<Void>> completionHandler)

      Unregisters the handler which created this registration
      Parameters:
        `completionHandler` - the handler called when the unregister is done. For example in a cluster when all nodes of the event bus have been unregistered.

Copyright © 2021 Eclipse. All rights reserved.